<?php
/**
 * Copyright ©  All rights reserved.
 * See COPYING.txt for license details.
 */
declare(strict_types=1);

namespace Pinpoint\CarouselManager\Api;

use Magento\Framework\Api\SearchCriteriaInterface;

interface SlideRepositoryInterface
{

    /**
     * Save Slide
     * @param \Pinpoint\CarouselManager\Api\Data\SlideInterface $slide
     * @return \Pinpoint\CarouselManager\Api\Data\SlideInterface
     * @throws \Magento\Framework\Exception\LocalizedException
     */
    public function save(
        \Pinpoint\CarouselManager\Api\Data\SlideInterface $slide
    );

    /**
     * Retrieve Slide
     * @param string $slideId
     * @return \Pinpoint\CarouselManager\Api\Data\SlideInterface
     * @throws \Magento\Framework\Exception\LocalizedException
     */
    public function get($slideId);

    /**
     * Retrieve Slide matching the specified criteria.
     * @param \Magento\Framework\Api\SearchCriteriaInterface $searchCriteria
     * @return \Pinpoint\CarouselManager\Api\Data\SlideSearchResultsInterface
     * @throws \Magento\Framework\Exception\LocalizedException
     */
    public function getList(
        \Magento\Framework\Api\SearchCriteriaInterface $searchCriteria
    );

    /**
     * Delete Slide
     * @param \Pinpoint\CarouselManager\Api\Data\SlideInterface $slide
     * @return bool true on success
     * @throws \Magento\Framework\Exception\LocalizedException
     */
    public function delete(
        \Pinpoint\CarouselManager\Api\Data\SlideInterface $slide
    );

    /**
     * Delete Slide by ID
     * @param string $slideId
     * @return bool true on success
     * @throws \Magento\Framework\Exception\NoSuchEntityException
     * @throws \Magento\Framework\Exception\LocalizedException
     */
    public function deleteById($slideId);
}

